// AD&D Easy Character Generator
// by Martin Klein-Hennig
// Created 16.08.01; 16:24:52

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produce .89Z File

// Global variables for the user's ability scores

int strength=0,dexterity=0,constitution=0,intelligence=0,wisdom=0,charisma=0;
int aussergew=0,realstr=0;

// My favourite for() variable: i!

int i=0;


// These are the values which you can find in the AD&D rules

char *strtrefferchance[30]={"-5","-3","-3","-2","-2","-1","-1","Normal","Normal","Normal","Normal","Normal","Normal","Normal","Normal","Normal","+1","+1","+3","+3","+4","+4","+5","+6","+7","+1","+2","+2","+2","+3"};
char *strschadensmodifikation[30]={"-4","-2","-1","-1","-1","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","+1","+1","+2","+7","+8","+9","+10","+11","+12","+14","+3","+3","+4","+5","+6"};
char *strtraglast[30]={"1","1","5","10","10","20","20","35","35","40","40","45","45","55","55","70","85","110","485","535","635","785","935","1235","1535","135","160","185","235","335"};
char *strstemm[30]={"3","5","10","25","25","55","55","90","90","115","115","140","140","170","170","195","220","255","640","700","810","970","1130","1440","1750","280","305","330","380","480"};
char *strtueren[30]={"1","1","2","3","3","4","4","5","5","6","6","7","7","8","8","9","10","11","16(8)","17(10)","17(12)","18(14)","18(16)","19(17)","19(18)","12","13","14","15(3)","16(6)"};
char *strstangen[30]={"0%","0%","0%","0%","0%","0%","0%","1%","1%","2%","2%","4%","4%","7%","7%","10%","13%","16%","50%","60%","70%","80%","90%","95%","99%","20%","25%","30%","35%","40%"};
char *dexreaktion[25]={"-6","-4","-3","-2","-1","0","0","0","0","0","0","0","0","0","0","+1","+2","+2","+3","+3","+4","+4","+4","+5","+5"};
char *dexfernwaffen[25]={"-6","-4","-3","-2","-1","0","0","0","0","0","0","0","0","0","0","+1","+2","+2","+3","+3","+4","+4","+4","+5","+5"};
char *dexausweich[25]={"+5","+5","+4","+3","+2","+1","0","0","0","0","0","0","0","0","-1","-2","-3","-4","-4","-4","-5","-5","-5","-6","-6"};
char *contrefferpunkte[25]={"-3","-2","-2","-1","-1","-1","0","0","0","0","0","0","0","0","+1","+2","+2 (+3)","+2 (+4)","+2 (+5)","+2 (+5)","+2 (+6)","+2 (+6)","+2 (+6)","+2 (+7)","+2 (+7)"};
char *conschock[25]={"25%","30%","35%","40%","45%","50%","55%","60%","65%","70%","75%","80%","85%","88%","90%","95%","97%","99%","99%","99%","99%","99%","99%","99%","100%"};
char *conwieder[25]={"30%","35%","40%","45%","50%","55%","60%","65%","70%","75%","80%","85%","90%","92%","94%","96%","98%","100%","100%","100%","100%","100%","100%","100%","100%"};
char *congift[25]={"-2","-1","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","0","+1","+1","+2","+2","+3","+3","+4"};
char *conreg[25]={"Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","Keine","1/6 Phasen","1/5 Phasen","1/4 Phasen","1/3 Phasen","1/2 Phasen","1/1 Phase"};
char *intsprachen[25]={"0","1","1","1","1","1","1","1","2","2","2","3","3","4","4","5","6","7","8","9","10","11","12","15","20"};
char *intzaubergrad[25]={"-","-","-","-","-","-","-","-","Vier","Fnf","Fnf","Sechs","Sechs","Sieben","Sieben","Acht","Acht","Neun","Neun","Neun","Neun","Neun","Neun","Neun","Neun"};
char *intchance[25]={"-","-","-","-","-","-","-","-","35%","40%","45%","50%","55%","60%","65%","70%","75%","85%","95%","96%","97%","98%","99%","100%","100%"};
char *inthoechstzahl[25]={"-","-","-","-","-","-","-","-","6","7","7","7","9","9","11","11","14","18","Alle","Alle","Alle","Alle","Alle","Alle","Alle"};
char *intimmunillu[25]={"-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","-","1. Grades","2. Grades","3.Grades","4. Grades","5. Grades","6. Grades","7. Grades"};
char *wismodmagie[25]={"-6","-4","-3","-2","-1","-1","-1","0","0","0","0","0","0","0","+1","+2","+3","+4","+4","+4","+4","+4","+4","+4","+4"};
char *wiszusatz[25]={"-","-","-","-","-","-","-","-","0","0","0","0","1. Grad","1. Grad","2. Grad","2. Grad","3. Grad","4. Grad","1.+4. Grad","2.+4. Grad","3.+5. Grad","4.+5. Grad","1.+6. Grad","5.+6. Grad","6.+7. Grad"};
char *wisversag[25]={"80%","60%","50%","45%","40%","35%","30%","25%","20%","15%","10%","5%","0%","0%","0%","0%","0%","0%","0%","0%","0%","0%","0%","0%"};
char *wisimmun[7]={"Befehl\nFreundschaft\nFurcht erzeugen\nHypnose\nPersonen bezaubern\n","Personen festhalten\nErschecken\nVergessen\nStrahl der Schwchung\n","Furcht\n","Einflsterung\nGefhl\nMonster bezaubern\nUngeschicklichkeit\nVerwirrung\n","Auftrag\nChaos\nMagisches Gef\nMonster festhalten\nSchwachsinn\n","Geas\nMasseinflsterung\nZepter der Herrschaft\n","Antipathie/Sympathie\nMassenberzauberung\nTodeszauber\n"};
char *chagefolg[25]={"0","1","1","1","2","2","3","3","4","4","4","5","5","6","7","8","10","15","20","25","30","35","40","45","50"};
char *chaloyal[25]={"-8","-7","-6","-5","-4","-3","-2","-1","0","0","0","0","0","+1","+3","+4","+6","+8","+10","+12","+14","+16","+18","+20","+20"};
char *chareak[25]={"-7","-6","-5","-4","-3","-2","-1","0","0","0","0","0","+1","+2","+3","+5","+6","+7","+8","+9","+10","+11","+12","+13","+14"};


/*
* Self-made input routine which converts user input into an integer
* prompt is the string to be displayed while waiting for input
*/

int inputint(char *prompt, int min, int max)
{
	char pinput[20];
	int result=-1;
	while (result<min||result>max)
	{
		printf("%s",prompt);
		result=atoi(gets(pinput));	
	}
	return result;
}

/* 
* This is the nice text-mode "splash screen"
* Made with figlet
*/

void startScreen()
{
	clrscr();
	FontSetSys(F_8x10);
	printf("        _     _\n");
	printf("    /\\ | \\() | \\\n");
	printf("   /--\\|_/(_X|_/\n");
	printf("   -------------\n");
	printf("    EasyCharGen\n");
	printf("    by MartinKH\n");
	printf("     Enjoy....\n");
	ngetchx();
	FontSetSys(F_6x8);
	clrscr();	
}

/*
* This function displays the values according to the user's ability scores
*/

void outputValues()
{
	clrscr();
	if (aussergew>0)
		printf("Strke:%i/%i\n",realstr,aussergew);
	else
		printf("Strke:%i\n",realstr);
	printf("-------------------------\n");
	printf("\nTrefferchance: %s",strtrefferchance[strength-1]);
	printf("\nSchadensmod.: %s",strschadensmodifikation[strength-1]);
	printf("\nZul. Traglast: %s",strtraglast[strength-1]);
	printf("\nStemmvermgen: %s",strstemm[strength-1]);
	printf("\nTren ffnen: %s",strtueren[strength-1]);
	printf("\nSt. verb./Git. anheb.: %s",strstangen[strength-1]);
	ngetchx();
	clrscr();
	printf("Geschicklichkeit:%i\n",dexterity);
	printf("-------------------------\n");
	printf("\nReaktionsmod.: %s",dexreaktion[dexterity-1]);
	printf("\nFernwaffenmod.: %s",dexfernwaffen[dexterity-1]);
	printf("\nAusweichmod: %s",dexausweich[dexterity-1]);
	ngetchx();
	clrscr();
	printf("Konstitution: %i\n",constitution);
	printf("-------------------------\n");
	printf("\nTrefferpunkte: %s",contrefferpunkte[constitution-1]);
	printf("\nKrperl. Schock: %s",conschock[constitution-1]);
	printf("\nWiedererweckung: %s",conwieder[constitution-1]);
	printf("\nRettungsw. gg. Gift: %s",congift[constitution-1]);
	printf("\nRegeneration: %s",conreg[constitution-1]);
	ngetchx();
	clrscr();
	printf("Intelligenz: %i\n",intelligence);
	printf("-------------------------\n");
	printf("\nAnzahl Sprachen: %s",intsprachen[intelligence-1]);
	printf("\nMax. Zaubergrad: %s",intzaubergrad[intelligence-1]);
	printf("\nZauber verstehen: %s",intchance[intelligence-1]);
	printf("\nMax. Zauber pro Grad: %s",inthoechstzahl[intelligence-1]);
	printf("\nImmun gg. Illu.: %s",intimmunillu[intelligence-1]);
	ngetchx();
	clrscr();
	printf("Weisheit: %i\n",wisdom);
	printf("-------------------------\n");
	printf("\nMod. gg. Magie: %s",wismodmagie[wisdom-1]);
	printf("\nZus. Zauber: %s",wiszusatz[wisdom-1]);
	printf("\nChance fr Fehlgang: %s",wisversag[wisdom-1]);

/*
* Output the player's spell immunity (eventually uses several pages)
*/


	if (wisdom<=18)
		printf("\nImmunitt gg. Zauber: -\n");
	ngetchx();
	if (wisdom>18)
	{
		for (i=0;i<wisdom-18;i++)
		{
			clrscr();
			printf("Immunitt gg. Zauber:\n%s",wisimmun[i]);
			ngetchx();
		}
	}
	clrscr();
	printf("Charisma: %i\n",charisma);
	printf("-------------------------\n");
	printf("\nMax. Gefolgsleute: %s",chagefolg[charisma-1]);
	printf("\nGrundloyalitt: %s",chaloyal[charisma-1]);
	printf("\nReaktionsmod.: %s",chareak[charisma-1]);
	ngetchx();
}

/*
* This function gets the user's ability scores. It uses the function inputint
*/

void inputStats()
{
	strength=inputint("Strke:",1,25);
	realstr=strength;

/*
* Ask for exceptional strength
*/

	if (strength==18)
	{
		aussergew=inputint("Aussergewhnl. Strke:",0,100);
	}
	if (aussergew>=1&&aussergew <=50)
		strength=26;
	if (aussergew>=51&&aussergew<=75)
		strength=27;
	if (aussergew>=76&&aussergew<=90)
		strength=28;
	if (aussergew>=91&&aussergew<=99)
		strength=29;
	if (aussergew==100)
		strength=30;

	dexterity=inputint("Geschicklichkeit: ",1,25);
	constitution=inputint("Konstitution: ",1,25);
	intelligence=inputint("Intelligenz: ",1,25);
	wisdom=inputint("Weisheit: ",1,25);
	charisma=inputint("Charisma: ",1,25);
}

/*
* Main function
*/


void _main(void)
{
	strength=0,dexterity=0,constitution=0,intelligence=0,wisdom=0,charisma=0,i=0;
	aussergew=0,realstr=0;
	startScreen();
	inputStats();
	outputValues();
}

